//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "rx32_main.h"
#include "freq_form.h"

#include "inc\hardware.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFreqForm *FreqForm;
//---------------------------------------------------------------------------
__fastcall TFreqForm::TFreqForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

int __fastcall TFreqForm::Execute(unsigned F)
{
   int t = Form1->Delay_MaskEdit->Text.ToInt();
   FreqInfo *pFI = Form1->GetFreqInfo(ToMHz(F));
   Flag = 0;

   F_MaskEdit->Text = F;
   FComment_Memo->Text = (pFI) ? pFI->Comment : AnsiString("");
   FComment_Memo->Modified = false;

    Known_CheckBox->Checked = (pFI) ? pFI->Known  : false;
   Ignore_CheckBox->Checked = (pFI) ? pFI->Ignore : false;

   SaveFComment_CheckBox->Checked = false;
   Show();
   Continue_BitBtn->SetFocus();

   Time_ProgressBar->Max = 100 * t;
   TimeStop = false;

   for(TimeCount = 0; TimeCount < 100 * t; TimeCount++)
   {
      if(Flag) break;
      if(Pause_SpeedButton->Down || RX_CarrierDetect() || TimeStop) TimeCount = 0;

      if(TimeCount) Sleep(10);
      Time_ProgressBar->Position = TimeCount;
      Application->ProcessMessages();
   }
   if(Flag == 1) Flag--;

   if(SaveFComment_CheckBox->Checked) Form1->SetFreqInfo(ToMHz(F), Known_CheckBox->Checked, Ignore_CheckBox->Checked, FComment_Memo->Text);
   if(IgnoreNow_CheckBox->Checked) Flag += 20;

   return Flag;   // 0 - continue, 1 - stop, 10 - step down, 12- step up, >= 20 - ignore now
}
//---------------------------------------------------------------------------

void __fastcall TFreqForm::Continue_BitBtnClick(TObject *Sender)
{
   Flag = 1;
}
//---------------------------------------------------------------------------

void __fastcall TFreqForm::Stop_BitBtnClick(TObject *Sender)
{
   Flag = 2;
}
//---------------------------------------------------------------------------

void __fastcall TFreqForm::FComment_MemoEnter(TObject *Sender)
{
   TimeStop = true;
}
//---------------------------------------------------------------------------

void __fastcall TFreqForm::FComment_MemoExit(TObject *Sender)
{
   TimeStop = false;
}
//---------------------------------------------------------------------------

void __fastcall TFreqForm::FComment_MemoChange(TObject *Sender)
{
   if(FComment_Memo->Modified) SaveFComment_CheckBox->Checked = true;
}
//---------------------------------------------------------------------------


void __fastcall TFreqForm::CheckBoxClick(TObject *Sender)
{
   SaveFComment_CheckBox->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TFreqForm::UpDown_SpeedButtonClick(TObject *Sender)
{
   Flag = 11 + ((TSpeedButton *) Sender)->Tag;
}
//---------------------------------------------------------------------------

