//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "intrface.h"
#include "function.h"

#include "freq_inp.h"
#include "rx32_main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFreqInputForm *FreqInputForm;
//---------------------------------------------------------------------------
__fastcall TFreqInputForm::TFreqInputForm(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TFreqInputForm::RadioButtonClick(TObject *Sender)
{
   bool x = B_RadioButton->Checked;

   if(x)
   {
      this->Caption = "  ";
      Fmax_Label->Caption = "Fmax:";
   }
   else
   {
      this->Caption = " ";
      Fmax_Label->Caption = ":";
   }

   Fmin_Label->Visible = x;
   FminUnit_Label->Visible = x;
   Step_Label->Visible = x;
   StepUnit_Label->Visible = x;
   Edit1->Visible = x;
   Edit3->Visible = x;
}
//---------------------------------------------------------------------------

int __fastcall TFreqInputForm::Execute(double &f1, double &f2, double &f3)
{
   Show();
   Edit1->SetFocus();

   while(!AllowExit)
   {
      Application->ProcessMessages();
   }
   if(!IsCancel)
   {
      if(B_RadioButton->Checked)
      {
         f1 = ToDouble(Edit1->Text);
         f2 = ToDouble(Edit2->Text);
         f3 = ToDouble(Edit3->Text);
      }
      else
      {
         f1 = ToDouble(Edit2->Text);
         f2 = 0;
         f3 = 0;
      }
   }

   return IsCancel;
}
//---------------------------------------------------------------------------

int __fastcall TFreqInputForm::Execute(double &f)
{
   B_RadioButton->Checked = false;
   B_RadioButton->Enabled = false;
   F_RadioButton->Checked = true;
   F_RadioButton->Enabled = false;
   RadioButtonClick(this);

   Show();
   Edit2->SetFocus();

   while(!AllowExit)
   {
      Application->ProcessMessages();
   }
   if(!IsCancel) f = ToDouble(Edit2->Text);

   return IsCancel;
}
//---------------------------------------------------------------------------

void __fastcall TFreqInputForm::OK_BitBtnClick(TObject *Sender)
{
   double f1, f2, f3;

   AllowExit = false;
   IsCancel  = false;

   try
   {
      f2 = ToDouble(Edit2->Text);

      if(B_RadioButton->Checked)
      {
         f1 = ToDouble(Edit1->Text);
         f3 = ToDouble(Edit3->Text);

         if(f3 < 1)
         {
            ShowMessage(MSG_ERROR, "!\n      1 .");
            return;
         }
         if(Form1->ValidateFrequency(f1)) return;
      }
      if(Form1->ValidateFrequency(f2)) return;

      if(B_RadioButton->Checked)
      {
         if(f2 - f1 < f3 / 1000)
         {
            ShowMessage(MSG_ERROR, "     !\n       .");
            return;
         }
      }
      AllowExit = true;
   }
   catch(Exception &EConvertError)
   {
      ShowMessage(MSG_ERROR, "   !\n  .");
   }
}
//---------------------------------------------------------------------------
void __fastcall TFreqInputForm::Cancel_BitBtnClick(TObject *Sender)
{
   AllowExit = true;
   IsCancel = true;
}
//---------------------------------------------------------------------------
