#include "rx32_main.h"

#include "inc\lpt32.h"
#include "inc\function.h"

#define DELAY_T 1

//--------------------------------------------------------------------------
inline void SCL_Set(bool x)
{
   SetPortBit(Form1->SCL_RadioGroup->ItemIndex, x);
   IO_delay(DELAY_T);
}

inline void SDA_Write(bool x)
{
   SetPortLine(Form1->SDAout_RadioGroup->ItemIndex, x);
   IO_delay(DELAY_T);
}

inline unsigned char SDA_Read()
{
   return ReadPortLine(Form1->SDAin_RadioGroup->ItemIndex);
}
//--------------------------------------------------------------------------



void I2C_Start()
{
   SCL_Set(1);                                // SCL - high
   SDA_Write(0);                              // SDA - low
}

void I2C_Stop()
{
   SDA_Write(0);
   SCL_Set(1);                                // SCL - high
   SDA_Write(1);                              // SDA - high
}



int I2C_SendByte(unsigned char x)
{
   int i;
   SCL_Set(0);

   for(i = 7; i >= 0; i--)
   {
      SDA_Write(x & (1 << i));
      SCL_Set(1);
      SCL_Set(0);
   }

   SDA_Write(1);
   SCL_Set(1);

   if(SDA_Read())
   {
      I2C_Stop();
      return -1;
   }
   SCL_Set(0);
   return 0;
}


unsigned char I2C_ReadByte(bool UseAck)       // default UseAck = 0
{
   unsigned char x = 0;
   SCL_Set(0);

   for(int i = 7; i >= 0; i--)
   {
      SCL_Set(1);
      x += (1 << i) * SDA_Read();
      SCL_Set(0);
   }

   if(UseAck)
   {
      SDA_Write(0);
      SCL_Set(1);
      SCL_Set(0);
   }

   return x;
}
