//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "input_form.h"
#include "inc\intrface.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TInputForm *InputForm;
//---------------------------------------------------------------------------
__fastcall TInputForm::TInputForm(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

// STRING
bool InputDialog(const AnsiString Caption, const AnsiString Question, AnsiString &Value, bool ShowDefault, int MaxLength)
{
   TInputForm *p;

   AnsiString s = "";
   int i;

   if(ShowDefault) s = Value;

   p = new TInputForm(NULL);
   p->Caption = Caption;
   p->Label->Caption = Question;
   p->Edit->Text = s;
   p->Edit->MaxLength = MaxLength;
   i = p->ShowModal();
   s = p->Edit->Text;
   delete p;

   if(i == mrCancel) return false;

   Value = s;
   return true;
}



bool InputIntegerDialog(const AnsiString Caption, const AnsiString Question, int &Value, bool ShowDefault, int min, int max, bool AllowBounds)
{
   int x;
   AnsiString s = Value, msg;

   while(1)
   {
      if(!InputDialog(Caption, Question, s, ShowDefault)) return false;

      try
      {
         x = s.ToInt();
      }
      catch(Exception &EConvertError)
      {
         ShowMessage(MSG_WARNING, "   !");
         continue;
      }

      if((min || max) && ( (AllowBounds && (x < min || x > max)) || (!AllowBounds && (x <= min || x >= max)) ) )
      {
         msg = "    " + AnsiString(min) + "  " + AnsiString(max) + "\n";
         msg += (AnsiString) "(" + (AllowBounds ? "" : "") + " )";
         ShowMessage(MSG_WARNING, msg);
      }
      else
      {
         Value = x;
         return true;
      }
   }
}



bool InputDoubleDialog(const AnsiString Caption, const AnsiString Question, double &Value, bool ShowDefault, double min, double max, bool AllowBounds)
{
   double x;
   AnsiString s = Value, msg;

   while(1)
   {
      if(!InputDialog(Caption, Question, s, ShowDefault)) return false;

      try
      {
         for(int i = 1; i <= s.Length(); i++) if(s[i] == ',' || s[i] == '.') s[i] = DecimalSeparator;

         x = s.ToDouble();
      }
      catch(Exception &EConvertError)
      {
         ShowMessage(MSG_WARNING, "   !");
         continue;
      }

      if((min || max) && ( (AllowBounds && (x < min || x > max)) || (!AllowBounds && (x <= min || x >= max)) ) )
      {
         msg = "    " + AnsiString(min) + "  " + AnsiString(max) + "\n";
         msg += (AnsiString) "(" + (AllowBounds ? "" : "") + " )";
         ShowMessage(MSG_WARNING, msg);
      }
      else
      {
         Value = x;
         return true;
      }
   }
}

