//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <math.h>

#include "rx32_main.h"
#include "scan.h"
#include "freq_inp.h"
#include "input_form.h"

#include "inc\lpt32.h"
#include "inc\intrface.h"
#include "inc\function.h"
#include "inc\hardware.h"
#include "ks_protocol_form.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

#define INI_FILENAME ChangeFileExt(Application->ExeName, ".ini")
#define  CH_FILENAME ExtractFileDir(Application->ExeName) + "\\channels.ini"

//---------------------------------------------------------------------------


void __fastcall TForm1::SetFreq_ButtonClick(TObject *Sender)
{
   unsigned long F1 = Freq_MaskEdit->Text.ToInt();
   FreqInfo *pFI;

   if(ValidateFrequency(F1)) return;

   F1 += ((TButton *) Sender)->Tag * (1000.0 * ToDouble(Step_ComboBox->Text));

   if(F1 < MinF || F1 > MaxF)
   {
      MessageBeep(MB_ICONASTERISK);
      ShowWarningString("   ,    !");
      return;
   }
   ShowWarningString("");
   F = F1;

   Freq_MaskEdit->Text = F;
   SetFrequency(F, true);

   pFI = GetFreqInfo(ToMHz(F));
   Comment_Memo->Text = (pFI) ? pFI->Comment : AnsiString("");
   CommentKnown_CheckBox ->Checked = (pFI) ? pFI->Known  : false;
   CommentIgnore_CheckBox->Checked = (pFI) ? pFI->Ignore : false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CommentSave_ButtonClick(TObject *Sender)
{
   FreqInfo *pFI = GetFreqInfo(ToMHz(F));
   bool flag = false;

   if(!pFI)
   {
      flag = true;

      pFI = new FreqInfo;
      pFI->F = ToMHz(F);
   }
   pFI->Comment = Comment_Memo->Text;
   pFI->Known   = CommentKnown_CheckBox ->Checked;
   pFI->Ignore  = CommentIgnore_CheckBox->Checked;

   if(flag) pFreqList->Add(pFI);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CommentCancel_ButtonClick(TObject *Sender)
{
   FreqInfo *pFI = GetFreqInfo(ToMHz(F));

   Comment_Memo->Text = (pFI) ? pFI->Comment : AnsiString("");
   CommentKnown_CheckBox ->Checked = (pFI) ? pFI->Known  : false;
   CommentIgnore_CheckBox->Checked = (pFI) ? pFI->Ignore : false;
}
//---------------------------------------------------------------------------








//===========================================================================
//========================== LOAD AND SAVE INI FILE =========================
//===========================================================================

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   bool x;
   int a, i;

   TStringList *pSL;
   FreqInfo *pFreqInfo;
   AnsiString s;

   Mute = false;
   ScanActive = false;

   delay_ms(1);  // QPF init

   ini    = new TIniFile(INI_FILENAME);
   ch_ini = new TIniFile(CH_FILENAME);

//
   F = ini->ReadInteger("RX", "Frequency", 150000000);
   Step_ComboBox->Text = ini->ReadString("RX", "Step", "25");
//
      SCL_RadioGroup->ItemIndex = ini->ReadInteger("KS-H-148", "SCL",     3);
    SDAin_RadioGroup->ItemIndex = ini->ReadInteger("KS-H-148", "SDA-in",  2);
   SDAout_RadioGroup->ItemIndex = ini->ReadInteger("KS-H-148", "SDA-out", 0);
         AS_ComboBox->ItemIndex = ini->ReadInteger("KS-H-148", "AS",      1);
   LOW_MaxFreq_MaskEdit->Text   = ini->ReadInteger("KS-H-148", "LOW_Fmax", 184000);
   MID_MaxFreq_MaskEdit->Text   = ini->ReadInteger("KS-H-148", "MID_Fmax", 478000);

   CB       = ini->ReadInteger("KS-H-148", "CB",       0);  // except MSB=1
   BSB_Low  = ini->ReadInteger("KS-H-148", "BSB_Low",  1);
   BSB_Mid  = ini->ReadInteger("KS-H-148", "BSB_Mid",  2);
   BSB_High = ini->ReadInteger("KS-H-148", "BSB_High", 4);

//
           CE_RadioGroup->ItemIndex = ini->ReadInteger("LC72131", "CE", 0);
           CL_RadioGroup->ItemIndex = ini->ReadInteger("LC72131", "CL", 1);
           DI_RadioGroup->ItemIndex = ini->ReadInteger("LC72131", "DI", 2);
           DO_RadioGroup->ItemIndex = ini->ReadInteger("LC72131", "DO", 1);
         XTAL_RadioGroup->ItemIndex = ini->ReadInteger("LC72131", "XTAL", 1);
   LC72131_Step_ComboBox->ItemIndex = ini->ReadInteger("LC72131", "Step", 3);

   BO1_CheckBox->Checked = ini->ReadInteger("LC72131", "BO1", 1);
   BO2_CheckBox->Checked = ini->ReadInteger("LC72131", "BO2", 1);
   BO3_CheckBox->Checked = ini->ReadInteger("LC72131", "BO3", 1);
   BO4_CheckBox->Checked = ini->ReadInteger("LC72131", "BO4", 1);


   x = ini->ReadBool("LC72131", "Mode", 1);
   LC72131_AMIN_RadioButton->Checked = x;
   LC72131_FMIN_RadioButton->Checked = !x;
//
     CD_RadioGroup->ItemIndex = ini->ReadInteger("Receiver", "CD",   0);
   Mute_RadioGroup->ItemIndex = ini->ReadInteger("Receiver", "MUTE", 4);

   IF1_MaskEdit->Text = ini->ReadInteger("Receiver", "IF1", 38000);
   IF2_MaskEdit->Text = ini->ReadInteger("Receiver", "IF2", 10700);

   KSMonitoring_CheckBox->Checked = ini->ReadInteger("Receiver", "KS_Monitor", 1);
   UseADC_CheckBox->Checked       = ini->ReadInteger("Receiver", "UseADC", 0);
   Delay_MaskEdit->Text           = ini->ReadInteger("Receiver", "ScanDelay", 10);
   PLLTimeout_MaskEdit->Text      = ini->ReadInteger("Receiver", "PLLTimeout", 50);
   Time_TrackBar->Position        = ini->ReadInteger("Receiver", "HWDelay", 2);
   TimeMul_ComboBox->ItemIndex    = ini->ReadInteger("Receiver", "HWDelayMul", 4);
   SQLWait_MaskEdit->Text         = ini->ReadInteger("Receiver", "SQLDelay", 0);

   NoKS   = ini->ReadInteger("Receiver", "NoKS", 0);

   MinF = ini->ReadInteger("Receiver", "MinFrequency",  40000000);
   MaxF = ini->ReadInteger("Receiver", "MaxFrequency", 900000000);
   MinFreq_Edit->Text = (double) MinF / 1000000;
   MaxFreq_Edit->Text = (double) MaxF / 1000000;

   a = ini->ReadInteger("Window", "Left", -1);
   if(a < 0) a = 0;
   if(a < 600) Form1->Left = a;
   a = ini->ReadInteger("Window", "Top", -1);
   if(a < 0) a = 0;
   if(a < 450) Form1->Top = a;


   pSL = new TStringList;

   ini->ReadSection("ScanList", pSL);
   for(i = 0; i < pSL->Count; i++)
   {
      s = ini->ReadString("ScanList", pSL->Strings[i], "");
      if(s != "")
      {
         a = ScanList_CheckListBox->Items->Add(s);

         if(pSL->Strings[i].Pos("*")) ScanList_CheckListBox->Checked[a] = true;
      }
   }

   ini->ReadSection("IgnoreList", pSL);
   for(i = 0; i < pSL->Count; i++)
   {
      s = ini->ReadString("IgnoreList", pSL->Strings[i], "");
      if(s != "") IgnoreList_ListBox->Items->Add(s);
   }

   LoadFreqList();

   KS_StatusRecheck = true;
   SetPortBit(Mute_RadioGroup->ItemIndex, 0);

   SetFrequency(F, true);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
// "ini" was initialized on form creation
   int i;
   AnsiString s;

   ini->WriteInteger("RX", "Frequency", F);
   ini->WriteString("RX", "Step", Step_ComboBox->Text);

   ini->WriteInteger("KS-H-148", "SCL",      SCL_RadioGroup->ItemIndex);
   ini->WriteInteger("KS-H-148", "SDA-in",   SDAin_RadioGroup->ItemIndex);
   ini->WriteInteger("KS-H-148", "SDA-out",  SDAout_RadioGroup->ItemIndex);
   ini->WriteInteger("KS-H-148", "AS",       AS_ComboBox->ItemIndex);
   ini->WriteInteger("KS-H-148", "LOW_Fmax", LOW_MaxFreq_MaskEdit->Text.ToInt());
   ini->WriteInteger("KS-H-148", "MID_Fmax", MID_MaxFreq_MaskEdit->Text.ToInt());
   ini->WriteInteger("KS-H-148", "CB",       CB);
   ini->WriteInteger("KS-H-148", "BSB_Low",  BSB_Low);
   ini->WriteInteger("KS-H-148", "BSB_Mid",  BSB_Mid);
   ini->WriteInteger("KS-H-148", "BSB_High", BSB_High);


   ini->WriteInteger("LC72131", "CE",   CE_RadioGroup->ItemIndex);
   ini->WriteInteger("LC72131", "CL",   CL_RadioGroup->ItemIndex);
   ini->WriteInteger("LC72131", "DI",   DI_RadioGroup->ItemIndex);
   ini->WriteInteger("LC72131", "DO",   DO_RadioGroup->ItemIndex);
   ini->WriteInteger("LC72131", "XTAL", XTAL_RadioGroup->ItemIndex);
   ini->WriteInteger("LC72131", "Step", LC72131_Step_ComboBox->ItemIndex);
   ini->WriteInteger("LC72131", "Mode", LC72131_AMIN_RadioButton->Checked);
   ini->WriteInteger("LC72131", "BO1",  BO1_CheckBox->Checked);
   ini->WriteInteger("LC72131", "BO2",  BO2_CheckBox->Checked);
   ini->WriteInteger("LC72131", "BO3",  BO3_CheckBox->Checked);
   ini->WriteInteger("LC72131", "BO4",  BO4_CheckBox->Checked);

   ini->WriteInteger("Receiver", "CD",     CD_RadioGroup->ItemIndex);
   ini->WriteInteger("Receiver", "MUTE", Mute_RadioGroup->ItemIndex);

   ini->WriteInteger("Receiver", "IF1", IF1_MaskEdit->Text.ToInt());
   ini->WriteInteger("Receiver", "IF2", IF2_MaskEdit->Text.ToInt());
   ini->WriteInteger("Receiver", "KS_Monitor", KSMonitoring_CheckBox->Checked);
   ini->WriteInteger("Receiver", "UseADC", UseADC_CheckBox->Checked);
   ini->WriteInteger("Receiver", "ScanDelay", Delay_MaskEdit->Text.ToInt());
   ini->WriteInteger("Receiver", "PLLTimeout", PLLTimeout_MaskEdit->Text.ToInt());
   ini->WriteInteger("Receiver", "HWDelay", Time_TrackBar->Position);
   ini->WriteInteger("Receiver", "HWDelayMul", TimeMul_ComboBox->ItemIndex);
   ini->WriteInteger("Receiver", "SQLDelay", SQLWait_MaskEdit->Text.ToInt());

   ini->WriteInteger("Receiver", "MinFrequency", MinF);
   ini->WriteInteger("Receiver", "MaxFrequency", MaxF);

   ini->WriteInteger("Window", "Left", Form1->Left);
   ini->WriteInteger("Window", "Top", Form1->Top);

   ini->EraseSection("ScanList");
   for(i = 0; i < ScanList_CheckListBox->Items->Count; i++)
   {
      s = AnsiString(i);
      if(ScanList_CheckListBox->Checked[i]) s += "*";
      ini->WriteString("ScanList", s, ScanList_CheckListBox->Items->Strings[i]);
   }

   ini->EraseSection("IgnoreList");
   for(i = 0; i < IgnoreList_ListBox->Items->Count; i++)
   {
      ini->WriteString("IgnoreList", AnsiString(i), IgnoreList_ListBox->Items->Strings[i]);
   }
   UnLoadFreqList();

   delete ini;
   delete ch_ini;
} /**/
//---------------------------------------------------------------------------

//===========================================================================
//===========================================================================
//===========================================================================


// StatusBar->Tag: bits 0..1 - KS status: 00 - locked, 01 - unlock, 10- error
//                 bit     2 - LC72131 status: 0 - locked
//                 bit  3..5 - ADC reading for S-meter
//                 bit     6 - use ADC readings
//                 bit     7 - SQL on
//                 bit     8 - disable indication


void __fastcall TForm1::StatusBarDrawPanel(TStatusBar *StatusBar,
      TStatusPanel *Panel, const TRect &Rect)
{
   TCanvas *pCanvas = StatusBar->Canvas;
   int i, j, k, x, x0, y0;
   bool flag;

   x = Panel->Width - pCanvas->TextWidth(Panel->Text) - 5;

   i = Panel->Index;
   j = StatusBar->Tag;

   x0 = Rect.Left;
   y0 = Rect.Top;

   flag = !(j & 0x100);

   switch(i)
   {
      case 0: ImageList->Draw(pCanvas, x0, y0, 4, flag);
              ImageList->Draw(pCanvas, x0 + 1, y0 + 6, 3, flag);
              k = j & 3;

              ImageList->Draw(pCanvas, x0 + 13, y0 + 3, k, flag);
              pCanvas->TextOut(x0 + x, y0 + 4, Panel->Text);
              break;

      case 1: ImageList->Draw(pCanvas, x0 + 1, y0 + 3, 3, flag);
              k = (j >> 2) & 1;

              ImageList->Draw(pCanvas, x0 + 13, y0 + 3, k, flag);
              pCanvas->TextOut(x0 + x, y0 + 4, Panel->Text);
              break;

      case 2: if(j & 0x40 && flag)
              {
                 ImageList->Draw(pCanvas, x0 + 2, y0 + 3, 4, !(j & 3));
                 if(j & 3) break;
                 k = (j >> 3) & 7;

                 for(i = 0; i < 5; i++)
                 {
                    x = x0 + 22 + 9 * i;

                    pCanvas->Brush->Color = (i <= k) ? clNavy : clSilver;
                    pCanvas->FillRect(::Rect(x, y0 + 16 - 3 * i, x + 7, y0 + 20));
                 }
              }
              else
              {
                 pCanvas->Font->Color = clInactiveCaption;
                 pCanvas->TextOut(x0 + 26, y0 + 9, "( .)");
                 ImageList->Draw(pCanvas, x0 + 2, y0 + 3, 4, false);
              }
              break;

      case 3: ImageList->Draw(pCanvas, x0 + 2, y0 + 3, (j & 0x80) ? 0 : 5, flag);
              break;

      case 4: ImageList->Draw(pCanvas, x0 + 2, y0 + 3, Mute ? 7 : 6, flag);
              break;

   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StatusBarDblClick(TObject *Sender)
{
 //
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   static int a = 0;
   static bool WaitFlag = false;
   int b = 0;

   if(!ScanActive && (KSMonitoring_CheckBox->Checked || KS_StatusRecheck)) KSH148_ReadStatus();
   a = KSH148_StatusByte;

   if(a == -1 || !(a & 0x38)) b = 2;
   else
   if(!(a & 0x40)) b = 1;

   b |= (a & 7) << 3;
   b |= (UseADC_CheckBox->Checked) << 6 ;

   if(!LC72131_InLock()) b |= 4;

   b |= 0x80 * RX_CarrierDetect();

   if(StatusBar->Tag != b)
   {
      StatusBar->Tag = b;
      StatusBar->Repaint();
   }
   if(KS_StatusRecheck)
   {
      if(WaitFlag)
      {
         WaitFlag = false;
         KS_StatusRecheck = false;
      }
      else WaitFlag = true;
   }

   SetPortBit(Mute_RadioGroup->ItemIndex, Mute);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Freq_MaskEditKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
   if(Key == VK_RETURN) SetFreq_ButtonClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IF1_MaskEditExit(TObject *Sender)
{
   unsigned x = IF1_MaskEdit->Text.ToInt();

   if(x < 20000 || x > 50000)
   {
      ShowMessage(MSG_WARNING, "   1!\n(   20  50 )");
      IF1_MaskEdit->Text = ini->ReadInteger("Receiver", "IF1", 38000);
      IF1_MaskEdit->SetFocus();
   }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::IF2_MaskEditExit(TObject *Sender)
 {
   unsigned x = abs(IF2_MaskEdit->Text.ToInt());

   if(x < 400 || x > 30000)
   {
      ShowMessage(MSG_WARNING, "   2!\n(   400  30000    )");
      IF2_MaskEdit->Text = ini->ReadInteger("Receiver", "IF2", 10700);
      IF2_MaskEdit->SetFocus();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StatusBarMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   int x1 = 0;

   if(X < (x1 += StatusBar->Panels->Items[0]->Width))
   {
      StatusBar->Hint = "     ";
      return;
   }
   if(X < (x1 += StatusBar->Panels->Items[1]->Width))
   {
      StatusBar->Hint = "     LC72131";
      return;
   }
   if(X < (x1 += StatusBar->Panels->Items[2]->Width))
   {
      StatusBar->Hint = "       ";
      return;
   }
   if(X < (x1 += StatusBar->Panels->Items[3]->Width))
   {
      StatusBar->Hint = "  ";
      return;
   }
   if(X < (x1 += StatusBar->Panels->Items[4]->Width))
   {
      StatusBar->Hint = Mute ? " " : " ";
      return;
   }
   if(X < (x1 += StatusBar->Panels->Items[5]->Width))
   {
      StatusBar->Hint = "   ";
      return;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::KSMonitoring_CheckBoxClick(TObject *Sender)
{
   if(KSMonitoring_CheckBox->Checked)
   {
      UseADC_CheckBox->Enabled = true;
      UseADC_CheckBox->Checked = UseADC_CheckBox->Tag;
   }
   else
   {
      UseADC_CheckBox->Enabled = false;
      UseADC_CheckBox->Tag = UseADC_CheckBox->Checked;
      UseADC_CheckBox->Checked = false;
   }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ShowWarningString(const AnsiString s)
{
   int y;
   static TImage *pImage = NULL;
   static TLabel *pLabel = NULL;

   y = ClientHeight - StatusBar->Height - 18;

   if(s == "")
   {
      delete pImage;
      delete pLabel;
      pImage = NULL;
      pLabel = NULL;
      return;
   }

   if(!pImage) pImage = new TImage(this);
   if(!pLabel) pLabel = new TLabel(this);

   pImage->Parent = this;
   pImage->Height = 16;
   pImage->Width  = 16;
   pImage->Left   = 10;
   pImage->Top    = y;
   pImage->Transparent = true;

   ImageList->GetBitmap(1, pImage->Picture->Bitmap);

   pLabel->Parent  = this;
   pLabel->Left    = 30;
   pLabel->Top     = y + 2;
   pLabel->Caption = s;
}





//===========================================================================
//===========================================================================
//===========================================================================

void __fastcall TForm1::ScanStart_BitBtnClick(TObject *Sender)
{
   unsigned long f1, f2, f3;

   TScanForm *p = new TScanForm(this);

   for(int i = 0; i < ScanList_CheckListBox->Items->Count; i++)
   {
      if(!ScanList_CheckListBox->Checked[i]) continue;
      if(SplitFreqInterval(ScanList_CheckListBox->Items->Strings[i], f1, f2, f3) == 0)
      {
         ShowMessage(MSG_ERROR, "    !");
         return;
      }
      p->AddScanInterval(f1, f2, f3);
   }

//   this->Enabled = false;
   Control_TabSheet->Enabled = false;
   Scan_TabSheet->Enabled = false;
   Setup_TabSheet->Enabled = false;

   p->Execute();
//   this->Enabled = true;

   Control_TabSheet->Enabled = true;
   Scan_TabSheet->Enabled = true;
   Setup_TabSheet->Enabled = true;

   delete p;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ScanList_Del_SpeedButtonClick(TObject *Sender)
{
   ScanList_CheckListBox->Items->Delete(ScanList_CheckListBox->ItemIndex);
   ScanList_CheckListBoxClickCheck(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScanListUp_SpeedButtonClick(TObject *Sender)
{
   int x = ScanList_CheckListBox->ItemIndex;
   if(x < 1) return;

   ScanList_CheckListBox->Items->Move(x, x - 1);
   ScanList_CheckListBox->ItemIndex = x - 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScanListDown_SpeedButtonClick(TObject *Sender)
{
   int x = ScanList_CheckListBox->ItemIndex;
   if(x == -1 || x == ScanList_CheckListBox->Items->Count - 1) return;

   ScanList_CheckListBox->Items->Move(x, x + 1);
   ScanList_CheckListBox->ItemIndex = x + 1;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ScanList_New_SpeedButtonClick(TObject *Sender)
{
   if(MessageDlg(" ?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes)
   {
      ScanList_CheckListBox->Items->Clear();
      ScanList_CheckListBoxClickCheck(this);
   }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ScanList_Open_SpeedButtonClick(TObject *Sender)
{
   AnsiString FName;

   ScanList_OpenDialog->InitialDir = ExtractFileDir(Application->ExeName);
   if(ScanList_OpenDialog->Execute())
   {
      FName = ScanList_OpenDialog->FileName;

      ScanList_CheckListBox->Items->LoadFromFile(FName);
   };
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ScanList_Save_SpeedButtonClick(TObject *Sender)
{
   AnsiString FName;

   if(ScanList_CheckListBox->Items->Count == 0) return;

   ScanList_SaveDialog->InitialDir = ExtractFileDir(Application->ExeName);
   ScanList_SaveDialog->FileName = "";
   if(ScanList_SaveDialog->Execute())
   {
      FName = ScanList_SaveDialog->FileName;

      ScanList_CheckListBox->Items->SaveToFile(FName);
   };

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScanList_AddFreq_BitBtnClick(TObject *Sender)
{
   TFreqInputForm *p = new TFreqInputForm(this);
   double f1, f2, f3;
   AnsiString s;
   bool x;
   int i;

   this->Enabled = false;
   x = p->Execute(f1, f2, f3);
   this->Enabled = true;
   delete p;

   if(!x)
   {
      if(f2) s.printf("%.9g - %.9g - %.4g", f1, f2, f3);
      else s = f1;

      i = ScanList_CheckListBox->Items->Add(s);
      ScanList_CheckListBox->Checked[i] = true;
      ScanList_CheckListBox->ItemIndex = i;

      ScanList_CheckListBoxClickCheck(this);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IgnoreList_Add_BitBtnClick(TObject *Sender)
{
   TFreqInputForm *p = new TFreqInputForm(this);
   double f;
   bool x;

   this->Enabled = false;
   x = p->Execute(f);
   this->Enabled = true;
   delete p;

   if(!x)
   {
      IgnoreList_ListBox->ItemIndex = IgnoreList_ListBox->Items->Add(f);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IgnoreList_Del_SpeedButtonClick(TObject *Sender)
{
   IgnoreList_ListBox->Items->Delete(IgnoreList_ListBox->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MinMaxFreq_EditExit(TObject *Sender)
{
   double x;

   if(((TEdit *) Sender)->Modified)
   {
      try
      {
         x = ToDouble(((TEdit *) Sender)->Text);
      }
      catch(Exception &EConvertError)
      {
         ShowMessage(MSG_WARNING, "   !\n  .");
         ((TEdit *) Sender)->SetFocus();
         return;
      }

      if((TEdit *) Sender == MinFreq_Edit) MinF = x * 1000000;
      else                                 MaxF = x * 1000000;
   }
}
//---------------------------------------------------------------------------

//***************************************************************************
//***************************************************************************
//***************************************************************************
/*
void __fastcall TForm1::ValidateDouble(TObject *Sender)
{
   if(((TEdit *) Sender)->Modified)
   {
      try
      {
         ToDouble(((TEdit *) Sender)->Text);
      }
      catch(Exception &EConvertError)
      {
         ShowMessage(MSG_WARNING, "   !\n  .");
         ((TEdit *) Sender)->SetFocus();
      }
   }
}


void __fastcall TForm1::ValidateInteger(TObject *Sender)
{
   if(((TEdit *) Sender)->Modified)
   {
      try
      {
         ((TEdit *) Sender)->Text.ToInt();
      }
      catch(Exception &EConvertError)
      {
         ShowMessage(MSG_WARNING, "   !\n  .");
         ((TEdit *) Sender)->SetFocus();
      }
   }
}
*/


int __fastcall TForm1::ValidateFrequency(unsigned long Freq)
{
   AnsiString s;

   if(Freq < MinF || Freq > MaxF)
   {
      s = ",    " + AnsiString(ToMHz(Freq)) + " !\n";
      s += "   " + AnsiString(ToMHz(MinF)) + "  " + AnsiString(ToMHz(MaxF)) + " .\n";
      s += "\n        .";

      ShowMessage(MSG_ERROR, s);
      return -1;
   }
   return 0;
}


int __fastcall TForm1::ValidateFrequency(double Freq)
{
   AnsiString s;

   if(Freq < ToMHz(MinF) || Freq > ToMHz(MaxF))
   {
      s = ",    " + AnsiString(Freq) + " !\n";
      s += "   " + AnsiString(ToMHz(MinF)) + "  " + AnsiString(ToMHz(MaxF)) + " .\n";
      s += "\n        .";

      ShowMessage(MSG_ERROR, s);
      return -1;
   }
   return 0;
}

//---------------------------------------------------------------------------


void __fastcall TForm1::Control_TabSheetShow(TObject *Sender)
{
   Freq_MaskEdit->Text = F;
   CommentCancel_ButtonClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Hint_SpeedButtonClick(TObject *Sender)
{
   ShowMessage(MSG_INFORMATION, "     ,  \n ,  \" \". \n     \n   \"\".\n\n \" \"    \n  .");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScanList_CheckListBoxClickCheck(TObject *Sender)
{
   int i, j, Bcount, Fcount;
   unsigned long f1, f2, f3;

   for(i = 0, Bcount = 0, Fcount = 0; i < ScanList_CheckListBox->Items->Count; i++)
   {
      j = SplitFreqInterval(ScanList_CheckListBox->Items->Strings[i], f1, f2, f3);

      if(j == 0)
      {
         ShowMessage(MSG_ERROR, "      .\n  .");

         ScanList_CheckListBox->Items->Delete(i);
         i = 0;
         continue;
      }
      if(ScanList_CheckListBox->Checked[i])
      {
         if(j == 1) Bcount++;
         else Fcount++;
      }
   }

   i = !(Bcount || Fcount > 1);

   ScanWarning_Image ->Visible = i;
   ScanWarning_Label1->Visible = i;
   ScanWarning_Label2->Visible = i;
   ScanStart_BitBtn  ->Enabled = !i;
}
//---------------------------------------------------------------------------

int __fastcall TForm1::SplitFreqInterval(AnsiString s, unsigned long &Fmin, unsigned long &Fmax, unsigned long &Step)
{                                    // return value: 1 - interval
   int i, j, k;                      //               2 - single frequency
   AnsiString sf[3];                 //               0 - invalid data

   for(i = 0; i < 3; i++) sf[i] = "";

   for(i = 1, j = 0, k = 0; i <= s.Length(); i++)
   {
      if((s[i] >= '0' && s[i] <= '9') || s[i] == '.' || s[i] == ',' || s[i] == DecimalSeparator)
      {
         if(j > 2) return 0;

         sf[j] += s[i];
         k = 0;
      }
      else
      {
         if(!k) j++;
         k = 1;
      }
   }

   if(j < 2)
   {
      Fmin = ToHz(ToDouble(sf[0]));
      Fmax = 0;
      Step = 0;

      if(ValidateFrequency(Fmin)) return 0;
      return 2;
   }
   else
   {
      Fmin =  ToHz(ToDouble(sf[0]));
      Fmax =  ToHz(ToDouble(sf[1]));
      Step = ToDouble(sf[2]) * 1000;

      if(ValidateFrequency(Fmin)) return 0;
      if(ValidateFrequency(Fmax)) return 0;
      if(Step < 1)
      {
         ShowMessage(MSG_ERROR, "!\n      1 .");
         return 0;
      }
      return 1;
   }
}



void __fastcall TForm1::KS_Protocol_ButtonClick(TObject *Sender)
{
   TKS_Setup_Form *pKS_Setup_Form = new TKS_Setup_Form(this);

   pKS_Setup_Form->ShowModal();

   delete pKS_Setup_Form;
}
//---------------------------------------------------------------------------




