//---------------------------------------------------------------------------

#ifndef rx32_mainH
#define rx32_mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Mask.hpp>
#include <Buttons.hpp>
#include <jpeg.hpp>
#include <Graphics.hpp>

#include <IniFiles.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include <Grids.hpp>
#include <CheckLst.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------

inline double        ToMHz(unsigned long F)  { return (double) F / 1000000;    }
inline double        TokHz(unsigned long F)  { return (double) F / 1000;       }
inline unsigned long ToHz (double F)         { return (F * 1000000 + 0.5);     }


struct FreqInfo
{
   double F;
   bool Known;
   bool Ignore;
   AnsiString Comment;
};




class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TPageControl *MainPageControl;
        TTabSheet *Control_TabSheet;
        TTabSheet *Scan_TabSheet;
        TTabSheet *Setup_TabSheet;
        TMaskEdit *Freq_MaskEdit;
        TStatusBar *StatusBar;
        TGroupBox *GroupBox2;
        TBitBtn *FreqDown_BitBtn;
        TBitBtn *FreqUp_BitBtn;
        TComboBox *Step_ComboBox;
        TLabel *Label14;
        TLabel *Label15;
        TButton *SetFreq_Button;
        TLabel *Label16;
        TPageControl *SetupPageControl;
        TTabSheet *KS_TabSheet;
        TTabSheet *LC_TabSheet;
        TTabSheet *RX_TabSheet;
        TTabSheet *Misc_TabSheet;
        TMemo *Comment_Memo;
        TButton *CommentSave_Button;
        TButton *CommentCancel_Button;
        TGroupBox *GroupBox1;
        TLabel *Label1;
        TRadioGroup *SCL_RadioGroup;
        TLabel *Label2;
        TRadioGroup *SDAout_RadioGroup;
        TRadioGroup *SDAin_RadioGroup;
        TImage *Image1;
        TLabel *Label3;
        TLabel *Label4;
        TComboBox *AS_ComboBox;
        TMaskEdit *LOW_MaxFreq_MaskEdit;
        TMaskEdit *MID_MaxFreq_MaskEdit;
        TLabel *Label5;
        TLabel *Label6;
        TGroupBox *GroupBox3;
        TRadioGroup *CE_RadioGroup;
        TRadioGroup *CL_RadioGroup;
        TRadioGroup *DI_RadioGroup;
        TRadioGroup *DO_RadioGroup;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TRadioGroup *XTAL_RadioGroup;
        TGroupBox *GroupBox4;
        TRadioGroup *CD_RadioGroup;
        TLabel *Label11;
        TLabel *Label12;
        TRadioGroup *Mute_RadioGroup;
        TLabel *Label13;
        TCheckBox *UseADC_CheckBox;
        TGroupBox *GroupBox5;
        TComboBox *LC72131_Step_ComboBox;
        TRadioButton *LC72131_AMIN_RadioButton;
        TRadioButton *LC72131_FMIN_RadioButton;
        TLabel *Label17;
        TLabel *Label18;
        TGroupBox *GroupBox6;
        TMaskEdit *IF1_MaskEdit;
        TLabel *Label19;
        TLabel *Label20;
        TLabel *Label21;
        TLabel *Label22;
        TMaskEdit *IF2_MaskEdit;
        TImageList *ImageList;
        TTimer *Timer1;
        TCheckBox *KSMonitoring_CheckBox;
        TBitBtn *ScanStart_BitBtn;
        TMaskEdit *Delay_MaskEdit;
        TLabel *Label31;
        TGroupBox *GroupBox9;
        TSpeedButton *ScanListUp_SpeedButton;
        TSpeedButton *ScanListDown_SpeedButton;
        TBitBtn *ScanList_AddFreq_BitBtn;
        TSpeedButton *ScanList_Del_SpeedButton;
        TGroupBox *GroupBox7;
        TSpeedButton *IgnoreList_Del_SpeedButton;
        TListBox *IgnoreList_ListBox;
        TBitBtn *IgnoreList_Add_BitBtn;
        TSpeedButton *ScanList_New_SpeedButton;
        TSpeedButton *ScanList_Open_SpeedButton;
        TSpeedButton *ScanList_Save_SpeedButton;
        TLabel *Label23;
        TOpenDialog *ScanList_OpenDialog;
        TSaveDialog *ScanList_SaveDialog;
        TLabel *Label24;
        TCheckBox *IgnoreKnown_CheckBox;
        TTabSheet *Freq_TabSheet;
        TStringGrid *Freq_StringGrid;
        TSpeedButton *DelRow_SpeedButton;
        TSpeedButton *Add_SpeedButton;
        TCheckBox *NotUseIgnoreList_CheckBox;
        TCheckBox *FreqListSave_CheckBox;
        TGroupBox *GroupBox8;
        TEdit *MinFreq_Edit;
        TEdit *MaxFreq_Edit;
        TLabel *Label25;
        TLabel *Label26;
        TLabel *Label27;
        TLabel *Label28;
        TLabel *Label29;
        TCheckBox *CommentKnown_CheckBox;
        TCheckBox *CommentIgnore_CheckBox;
        TBevel *Bevel1;
        TLabel *Label30;
        TCheckBox *NotUseIgnoreFlag_CheckBox;
        TSpeedButton *Hint_SpeedButton;
        TCheckListBox *ScanList_CheckListBox;
        TImage *ScanWarning_Image;
        TLabel *ScanWarning_Label1;
        TLabel *ScanWarning_Label2;
        TMaskEdit *PLLTimeout_MaskEdit;
        TLabel *Label32;
        TGroupBox *GroupBox10;
        TTrackBar *Time_TrackBar;
        TMaskEdit *SQLWait_MaskEdit;
        TLabel *Label33;
        TLabel *Label34;
        TComboBox *TimeMul_ComboBox;
        TLabel *Label35;
        TButton *KS_Protocol_Button;
        TBevel *Bevel2;
        TGroupBox *GroupBox11;
        TCheckBox *BO1_CheckBox;
        TCheckBox *BO2_CheckBox;
        TCheckBox *BO3_CheckBox;
        TCheckBox *BO4_CheckBox;
        void __fastcall SetFreq_ButtonClick(TObject *Sender);
        void __fastcall CommentSave_ButtonClick(TObject *Sender);
        void __fastcall CommentCancel_ButtonClick(TObject *Sender);
        void __fastcall StatusBarDrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall Freq_MaskEditKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall IF1_MaskEditExit(TObject *Sender);
        void __fastcall IF2_MaskEditExit(TObject *Sender);
        void __fastcall StatusBarMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall KSMonitoring_CheckBoxClick(TObject *Sender);
        void __fastcall ScanStart_BitBtnClick(TObject *Sender);
        void __fastcall ScanList_Del_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanListUp_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanListDown_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanList_New_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanList_Open_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanList_Save_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanList_AddFreq_BitBtnClick(TObject *Sender);
        void __fastcall IgnoreList_Add_BitBtnClick(TObject *Sender);
        void __fastcall IgnoreList_Del_SpeedButtonClick(TObject *Sender);
        void __fastcall Add_SpeedButtonClick(TObject *Sender);
        void __fastcall DelRow_SpeedButtonClick(TObject *Sender);
        void __fastcall Freq_StringGridDblClick(TObject *Sender);
        void __fastcall Freq_StringGridMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Freq_StringGridDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall MinMaxFreq_EditExit(TObject *Sender);
        void __fastcall Freq_TabSheetShow(TObject *Sender);
        void __fastcall Control_TabSheetShow(TObject *Sender);
        void __fastcall Hint_SpeedButtonClick(TObject *Sender);
        void __fastcall ScanList_CheckListBoxClickCheck(TObject *Sender);
        void __fastcall StatusBarDblClick(TObject *Sender);
        void __fastcall KS_Protocol_ButtonClick(TObject *Sender);
          

private:	// User declarations

        TList *pFreqList;

        void __fastcall LoadFreqList();
        void __fastcall UnLoadFreqList();

//        void __fastcall TForm1::ValidateDouble (TObject *Sender);
//        void __fastcall TForm1::ValidateInteger(TObject *Sender);

        int __fastcall SplitFreqInterval(AnsiString s, unsigned long &Fmin, unsigned long &Fmax, unsigned long &Step);


public:		// User declarations
        unsigned long MinF, MaxF, F;                      // RX Freq. in Hz
        TIniFile *ini, *ch_ini;

        bool KS_StatusRecheck;
        bool ScanActive;
        bool Mute;
        bool NoKS;

        unsigned char CB, BSB_Low, BSB_Mid, BSB_High; // control & band switch bytes

        __fastcall TForm1(TComponent* Owner);

        void __fastcall ShowWarningString(const AnsiString s);

        int  __fastcall ValidateFrequency(unsigned long Freq);
        int __fastcall TForm1::ValidateFrequency(double Freq);

        FreqInfo *GetFreqInfo(double F);
        void __fastcall SetFreqInfo(double F, bool Known, bool Ignore, AnsiString Comment);


};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------

#endif
